function []=visu(Reperes,Camera,Mire)
% []=visu(Reperes,Camera,Mire)
%
% Dessine le robot, la mire et la camera en 3d
% dans la figure 1 et le robot et la mire en 2d
% (vus de la camera) dans la figure 2.

nbRep=size(Reperes,1)/4;

figure(2)
clf;
view(3);
hold on
axis([-1,1,-1,1])
axis ij

%axis([-500,500,-500,500])

figure(1)
clf;
view(3)
xlabel('x (mm)')
ylabel('y (mm)')
zlabel('z (mm)')
%maxi=max(abs(Reperes(:,4)));
maxi=[-1000;1000;-1000;1000;0;2000];
axis equal;
grid on
hold on;
taille=100;

R0=eye(4,4);
Rtranspose=Camera(1:3,1:3)';
RC=[Rtranspose, -Rtranspose*Camera(1:3,4); 0 0 0 1];
% Dessin de la camera dans le repere du robot
if 1
plot3d(RC,taille*[0,-1], taille*[0,-1], taille*[0,1],'b');
plot3d(RC,taille*[0,-1], taille*[0, 1], taille*[0,1],'b');
plot3d(RC,taille*[0, 1], taille*[0, 1], taille*[0,1],'b');
plot3d(RC,taille*[0, 1], taille*[0,-1], taille*[0,1],'b');

%axe x
plot3d(RC,taille*[0, 1], taille*[0,0], taille*[1,1],'m');
%axe y
plot3d(RC,taille*[0, 0], taille*[0,1], taille*[1,1],'c');

patch3d(RC,taille*[-1,-1,1,1,-1],...
  taille*[-1,1,1,-1,-1],taille*[1,1,1,1,1],'y');

end

PtMire=Reperes(4*nbRep-3:4*nbRep,:)*Mire...
   *[-100,-100,100,150,100,0;-100,100,100,0,-100,0;zeros(1,5),-10;ones(1,6)];
nbPtMire=size(PtMire,2);

figure(1)
X=[-50,-50,50,50];
Y=[-50,50,50,-50];
nbPt=length(X);
Z=zeros(1,nbPt);
patch(X,Y,Z,'r')
patch(PtMire(1,1:nbPtMire-1),PtMire(2,1:nbPtMire-1),PtMire(3,1:nbPtMire-1),'g');
%plot3d(R0,PtMire(1,nbPtMire),PtMire(2,nbPtMire),PtMire(3,nbPtMire),'.r');

figure(2)
view(-90,90)
P=Camera*[X;Y;Z;ones(1,nbPt)];
patch(P(2,:)./P(3,:),-P(1,:)./P(3,:),ones(1,nbPt),'r')
P=Camera*PtMire;
patch(P(2,1:nbPtMire-1)./P(3,1:nbPtMire-1),-P(1,1:nbPtMire-1)./P(3,1:nbPtMire-1),ones(1,nbPtMire-1),'g')
%plot3d(R0,P(2,nbPtMire)./P(3,nbPtMire),-P(1,nbPtMire)./P(3,nbPtMire),1,'or')

taille=10;
T=Reperes(1:4,:);

figure(1)
% Axe z
plot3d(R0,[T(1,4),T(1,4)+taille*T(1,3)],...
   [T(2,4),T(2,4)+taille*T(2,3)],...
   [T(3,4),T(3,4)+taille*T(3,3)],'r');
% Axe x
plot3d(R0,[T(1,4),T(1,4)+taille*T(1,1)],...
  [T(2,4),T(2,4)+taille*T(2,1)],...
  [T(3,4),T(3,4)+taille*T(3,1)],'g');


for i=2:nbRep
   T_1=T;
   T=Reperes(4*i-3:4*i,:);
   X=[T_1(1,4);T(1,4)];
   Y=[T_1(2,4);T(2,4)];
   Z=[T_1(3,4);T(3,4)];
   figure(1)
   plot3d(R0,X,Y,Z);
   figure(2)
   proj2d(Camera,X,Y,Z);
   % Axe z
   axe_z=taille*T*[0;0;1;0];
   X=[T(1,4),T(1,4)+axe_z(1)];
   Y=[T(2,4),T(2,4)+axe_z(2)];
   Z=[T(3,4),T(3,4)+axe_z(3)];
   figure(1)
   plot3d(R0,X,Y,Z,'r');
   
   % Axe x
   axe_x=taille*T*[1;0;0;0];
   X=[T(1,4),T(1,4)+axe_x(1)];
   Y=[T(2,4),T(2,4)+axe_x(2)];
   Z=[T(3,4),T(3,4)+axe_x(3)];
   figure(1)
   plot3d(R0,X,Y,Z,'g');
   
end


